#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/soundcard.h>



short int *process_buffer;
int snd_device_handle;
int sampling_frequency=44100;
int sample_format;
int nchan=2;
int blocksize=2048;
int card_blocksize;
char sound_device_name[80]="/dev/dsp";


int sound_start_playing(void)
{
	int fragments;
	int caps;
	audio_buf_info buf;

	if((snd_device_handle=open(sound_device_name, O_RDWR)) == -1) return 1;
	ioctl(snd_device_handle, SNDCTL_DSP_SETDUPLEX);

	ioctl(snd_device_handle, SNDCTL_DSP_GETCAPS, &caps);
	if((caps & DSP_CAP_DUPLEX) == 0) return 2;
	
	card_blocksize=blocksize * 2;
	
	if(card_blocksize!=0)
	{
		switch(card_blocksize)
		{
			case 64: fragments=0x00000006; break;
			case 128: fragments=0x00000007; break;
			case 256: fragments=0x00000008; break;
			case 1024: fragments=0x0000000A; break;
			case 2048: fragments=0x0000000D; break;
			default: fragments=0x0000000D; break;
		}
		fragments=fragments | 0x00080000;  /* 8 fragmentow */
	}
	else
	{
		card_blocksize=2048;
		fragments=0x0008000D;
	}

	ioctl(snd_device_handle, SNDCTL_DSP_SETFRAGMENT, &fragments);
	ioctl(snd_device_handle, SNDCTL_DSP_RESET);
	sample_format=AFMT_S16_LE;
	ioctl(snd_device_handle, SNDCTL_DSP_SETFMT, &sample_format);

	ioctl(snd_device_handle, SNDCTL_DSP_CHANNELS, &nchan);	

	if(ioctl(snd_device_handle, SNDCTL_DSP_SPEED, &sampling_frequency) == -1) return 3;

	ioctl(snd_device_handle, SNDCTL_DSP_GETBLKSIZE, &card_blocksize);

	process_buffer=(short int *)calloc(1, card_blocksize);
	blocksize=card_blocksize / 2;	

	return 0;
}



int sound_stop_playing(void)
{
	ioctl(snd_device_handle, SNDCTL_DSP_RESET);
	close(snd_device_handle);
	free(process_buffer);
}


int sound_write(void)
{
	return(write(snd_device_handle, process_buffer, card_blocksize));
}

int sound_read(void)
{
    int i, r;

    r=read(snd_device_handle, process_buffer, card_blocksize);
    
    if(nchan == 2) 
	for(i=0; i < blocksize; i+=2) 
	{
	    process_buffer[i]>>=1;
	    process_buffer[i + 1]=process_buffer[i];
	}
    
    return r;
}

