/* Unfinished yet but works */
#include <gtk/gtk.h>
#include <stdlib.h>
#include "plugin.h"
#include <math.h>


#define NUM_COMB 6
#define NUM_ALLPASS 4
#define NUM_DELAY 2
#define NUM_LOWPASS (NUM_COMB + 2)
#define PI M_PI
#define MAX_DELAY_COMB 0.200
#define MAX_DELAY_ALLPASS 0.030
#define MAX_DELAY_DELAYLINE 0.100
#define MAX_SAMPLING_FREQ 50000.0


typedef float DSPfloat;
typedef int DSPint;

int process(void *data, short int *smpdata, int size, int smpfreq, int nchan);
void *init(void);
void configure(void *data);
void cleanup(void *data);
Plugin *get_plugin_info(void);


Plugin plugin_info={"Reverb Plugin",
					cleanup,
					init,
					configure,
					process};




typedef struct
{
	DSPfloat *buffer;
	DSPint position;
	DSPint size;
	DSPint delay;
	DSPfloat delay_time;
} DSPdelay;

typedef struct
{
	DSPfloat y1;
	DSPfloat a0, b1;
	DSPfloat cutfreq;
} DSPlowpass;

typedef struct
{
	DSPfloat *delayline;
	DSPint position, size, delay;
	DSPfloat feedback_gain;
	DSPlowpass *lowpass_ptr;
	DSPfloat delay_time;
} DSPcomb;

typedef struct
{
	DSPfloat *delayline;
	DSPint position, size, delay;
	DSPfloat feedback_gain;
	DSPfloat delay_time;
} DSPallpass;


struct plugin_data
{
	GtkWidget *window;
	DSPfloat reverb_time, gain_wet, gain_dry, rscale, filter_freq;
	int sampling_frequency;
	int changed;
	DSPcomb *comb_data[NUM_COMB];
	DSPdelay *delay_data[NUM_DELAY];
	DSPallpass *allpass_data[NUM_ALLPASS];
	DSPlowpass *lowpass_data[NUM_LOWPASS];
	float old_smp;
};




Plugin *get_plugin_info(void)
{
	return &plugin_info;
}



inline DSPfloat check_range(DSPfloat data)
{
    if(data > 32760.0) data=32760.0;
    else if(data < -32760.0) data=-32760.0;
    return data;
}
/*****************************************************************************/
/*****************************************************************************/
DSPdelay *DSPdelay_alloc(DSPfloat delay_time, DSPfloat smpfreq)
{
  DSPdelay *temp;

  temp=(DSPdelay *)malloc(sizeof(DSPdelay));
  temp->size=(DSPint)(MAX_DELAY_DELAYLINE * MAX_SAMPLING_FREQ);
  temp->buffer=(DSPfloat *)malloc(sizeof(DSPfloat) * temp->size);
  temp->position=0;
  temp->delay=(DSPint)(delay_time * smpfreq);
  return temp;
}
/*****************************************************************************/
void DSPdelay_free(DSPdelay *obj)
{
  free(obj->buffer);
  free(obj);
}
/*****************************************************************************/
DSPfloat DSPdelay_update(DSPdelay *obj, DSPfloat data)
{
	DSPfloat temp;
	DSPint delayedsmp;

	delayedsmp=obj->position - obj->delay;
	if(delayedsmp < 0) delayedsmp+=obj->size;
	temp=obj->buffer[delayedsmp];
	obj->buffer[obj->position++]=data;
	if(obj->position >= obj->size) obj->position=0;
	return temp;
}
/*****************************************************************************/
/*****************************************************************************/
DSPlowpass *DSPlowpass_alloc(DSPfloat cut_freq, DSPfloat smpfreq)
{
	DSPlowpass *temp;

	temp=(DSPlowpass *)malloc(sizeof(DSPlowpass));
	temp->cutfreq=cut_freq;
	temp->y1=0.0;
	temp->b1=exp(-2.0 * PI * cut_freq / smpfreq);
	temp->a0=1.0 - temp->b1;
	return temp;
}

void DSPlowpass_recalc(DSPlowpass *obj, DSPfloat cut_freq, DSPfloat smpfreq)
{
	obj->y1=0.0;
	obj->b1=exp(-2.0 * PI * cut_freq / smpfreq);
	obj->a0=1.0 - obj->b1;
}


/*****************************************************************************/
void DSPlowpass_free(DSPlowpass *obj)
{
	free(obj);
}
/*****************************************************************************/
inline DSPfloat DSPlowpass_update(DSPlowpass *obj, DSPfloat data)
{
	obj->y1=obj->y1 * obj->b1 + obj->a0 * data;
	return obj->y1;
}
/*****************************************************************************/
/*****************************************************************************/
DSPcomb *DSPcomb_alloc(DSPfloat delayt, DSPfloat rt, DSPfloat fb, DSPfloat cutfreq, DSPfloat smpfreq)
{
	DSPcomb *temp;

	temp=(DSPcomb *)malloc(sizeof(DSPcomb));
	temp->delayline=(DSPfloat *)calloc((int)(MAX_DELAY_COMB * MAX_SAMPLING_FREQ), sizeof(DSPfloat));
	temp->delay=(DSPint)(delayt * smpfreq);
	temp->position=0;
	temp->delay_time=delayt;
	temp->size=(DSPint)(MAX_DELAY_COMB * MAX_SAMPLING_FREQ);
	if(fb == 0.0) temp->feedback_gain=pow(10.0, -3.0 * delayt / rt);
	else temp->feedback_gain=fb;
	if(cutfreq >= (smpfreq / 2.0 - 100.0))
	{
		temp->lowpass_ptr=DSPlowpass_alloc(smpfreq / 2.0 - 100.0, smpfreq);
		temp->lowpass_ptr->cutfreq=0.0;
	}
	else temp->lowpass_ptr=DSPlowpass_alloc(smpfreq, smpfreq);

	return temp;
}

inline DSPfloat DSPcomb_update(DSPcomb *obj, DSPfloat data)
{
	DSPfloat temp1, temp;
	DSPint delayed;

	delayed=obj->position - obj->delay;
	if(delayed < 0) delayed+=obj->size;
	temp=obj->delayline[delayed];
	temp1=temp;
	if(obj->lowpass_ptr->cutfreq > 0.0) temp=DSPlowpass_update(obj->lowpass_ptr, temp);
	temp=temp * obj->feedback_gain + data;
	obj->delayline[obj->position++]=temp;
	if(obj->position >= obj->size) obj->position=0;
	return temp1;
}

void DSPcomb_free(DSPcomb *obj)
{
	free(obj->delayline);
	DSPlowpass_free(obj->lowpass_ptr);
	free(obj);
}

void DSPcomb_recalc(DSPcomb *obj, DSPfloat delayt, DSPfloat rt, DSPfloat fb, DSPfloat cutfreq, DSPfloat smpfreq)
{
	obj->delay=(DSPint)(delayt * smpfreq);
	obj->position=0;
	if(fb == 0.0) obj->feedback_gain=pow(10.0, -3.0 * delayt / rt);
	else obj->feedback_gain=fb;

	if(cutfreq >= (smpfreq / 2.0 - 100.0))
	{
		DSPlowpass_recalc(obj->lowpass_ptr, cutfreq / 2.0 - 100.0, smpfreq);
		obj->lowpass_ptr->cutfreq=0.0;
	}
	else DSPlowpass_recalc(obj->lowpass_ptr, cutfreq, smpfreq);
}


DSPallpass *DSPallpass_alloc(DSPfloat delayt, DSPfloat rt, DSPfloat fb, DSPfloat smpfreq)
{
	DSPallpass *temp;

	temp=(DSPallpass *)malloc(sizeof(DSPallpass));
	temp->delayline=(DSPfloat *)calloc((int)(MAX_SAMPLING_FREQ * MAX_DELAY_ALLPASS), sizeof(DSPfloat));
	temp->delay=(DSPint)(delayt * smpfreq);
	temp->position=0;
	temp->size=(DSPint)(MAX_DELAY_ALLPASS * MAX_SAMPLING_FREQ);
	if(fb == 0.0) temp->feedback_gain=pow(10.0, -3.0 * delayt / rt);
	else temp->feedback_gain=fb;
	return temp;
}


inline DSPfloat DSPallpass_update(DSPallpass *obj, DSPfloat data)
{
	DSPfloat temp;
	DSPint delayed;

	delayed=obj->position - obj->delay;
	if(delayed < 0) delayed+=obj->size;
	temp=obj->delayline[delayed] - obj->feedback_gain * data;
	obj->delayline[obj->position++]=temp * obj->feedback_gain + data;
	if(obj->position >= obj->size) obj->position=0;
	return temp;
}


void DSPallpass_recalc(DSPallpass *obj, DSPfloat delayt, DSPfloat rt, DSPfloat fb, DSPfloat smpfreq)
{
	obj->delay=(DSPint)(delayt * smpfreq);
	obj->position=0;
	if(fb == 0.0) obj->feedback_gain=pow(10.0, -3.0 * delayt / rt);
	else obj->feedback_gain=fb;
}


void DSPallpass_free(DSPallpass *obj)
{
	free(obj->delayline);
	free(obj);
}



void init_reverb(struct plugin_data *pdata)
{
	pdata->allpass_data[0]=DSPallpass_alloc(0.0128, 0.0, 0.707,(float)(pdata->sampling_frequency));

	pdata->allpass_data[1]=DSPallpass_alloc(0.010, 0.0, 0.707, (float)(pdata->sampling_frequency));

	pdata->allpass_data[2]=DSPallpass_alloc(0.007, 0.0, 0.707, (float)(pdata->sampling_frequency));

	pdata->allpass_data[3]=DSPallpass_alloc(0.005, 0.0, 0.707, (float)(pdata->sampling_frequency));




	pdata->comb_data[0]=DSPcomb_alloc(0.0366, pdata->reverb_time, 0.0, pdata->filter_freq + 100.0, (float)(pdata->sampling_frequency));

	pdata->comb_data[1]=DSPcomb_alloc(0.0353, pdata->reverb_time, 0.0, pdata->filter_freq + 100.0, (float)(pdata->sampling_frequency));

	pdata->comb_data[2]=DSPcomb_alloc(0.0338, pdata->reverb_time, 0.0, pdata->filter_freq + 100.0, (float)(pdata->sampling_frequency));

	pdata->comb_data[3]=DSPcomb_alloc(0.0322, pdata->reverb_time, 0.0, pdata->filter_freq + 100.0, (float)(pdata->sampling_frequency));

	pdata->comb_data[4]=DSPcomb_alloc(0.0307, pdata->reverb_time, 0.0, pdata->filter_freq + 100.0, (float)(pdata->sampling_frequency));

	pdata->comb_data[5]=DSPcomb_alloc(0.0289, pdata->reverb_time, 0.0, pdata->filter_freq + 100.0, (float)(pdata->sampling_frequency));
}


void cleanup_reverb(struct plugin_data *pdata)
{
	DSPcomb_free(pdata->comb_data[0]);
	DSPcomb_free(pdata->comb_data[1]);
	DSPcomb_free(pdata->comb_data[2]);
	DSPcomb_free(pdata->comb_data[3]);
	DSPcomb_free(pdata->comb_data[4]);	
	DSPcomb_free(pdata->comb_data[5]);	
	DSPallpass_free(pdata->allpass_data[0]);
	DSPallpass_free(pdata->allpass_data[1]);
	DSPallpass_free(pdata->allpass_data[2]);	
	DSPallpass_free(pdata->allpass_data[3]);	
}


void modify_reverb(struct plugin_data *pdata)
{
	DSPcomb_recalc(pdata->comb_data[0], 0.0366, pdata->reverb_time, 0.0, pdata->filter_freq + 300.0, (float)(pdata->sampling_frequency));

	DSPcomb_recalc(pdata->comb_data[1], 0.0353, pdata->reverb_time, 0.0, pdata->filter_freq + 300.0, (float)(pdata->sampling_frequency));

	DSPcomb_recalc(pdata->comb_data[2], 0.0338, pdata->reverb_time, 0.0, pdata->filter_freq + 500.0, (float)(pdata->sampling_frequency));

	DSPcomb_recalc(pdata->comb_data[3], 0.0322, pdata->reverb_time, 0.0, pdata->filter_freq + 1000.0, (float)(pdata->sampling_frequency));

	DSPcomb_recalc(pdata->comb_data[4], 0.0307, pdata->reverb_time, 0.0, pdata->filter_freq + 300.0, (float)(pdata->sampling_frequency));

	DSPcomb_recalc(pdata->comb_data[5], 0.0289, pdata->reverb_time, 0.0, pdata->filter_freq + 300.0, (float)(pdata->sampling_frequency));



	DSPallpass_recalc(pdata->allpass_data[0], 0.0128, 0.0, 0.707, (float)(pdata->sampling_frequency));

	DSPallpass_recalc(pdata->allpass_data[1], 0.010, 0.0, 0.707, (float)(pdata->sampling_frequency));

	DSPallpass_recalc(pdata->allpass_data[2], 0.007, 0.0, 0.707, (float)(pdata->sampling_frequency));

	DSPallpass_recalc(pdata->allpass_data[3], 0.005, 0.0, 0.707, (float)(pdata->sampling_frequency));
}





void config_destroy(GtkWidget *w, struct plugin_data *pdata)
{
	if(pdata->window != NULL) gtk_widget_destroy(pdata->window);
	pdata->window=NULL;
}


void reverb_time_update(GtkWidget *w, struct plugin_data *pdata)
{
	pdata->reverb_time=(GTK_ADJUSTMENT(w))->value;
	pdata->changed=1;
}

void dry_gain_update(GtkWidget *w, struct plugin_data *pdata)
{
	pdata->gain_dry=(GTK_ADJUSTMENT(w))->value / 100.0;
	pdata->changed=1;
}

void wet_gain_update(GtkWidget *w, struct plugin_data *pdata)
{
	pdata->gain_wet=(GTK_ADJUSTMENT(w))->value / 100.0;
	pdata->changed=1;
}

void lowpass_freq_update(GtkWidget *w, struct plugin_data *pdata)
{
	pdata->filter_freq=(GTK_ADJUSTMENT(w))->value;
	pdata->changed=1;
}


float reverb(struct plugin_data *pdata, float smp)
{
	float tmp, tmp2;

	tmp=DSPcomb_update(pdata->comb_data[0], smp);
	tmp+=DSPcomb_update(pdata->comb_data[1], smp);
	tmp+=DSPcomb_update(pdata->comb_data[2], smp);
	tmp+=DSPcomb_update(pdata->comb_data[3], smp);
	tmp+=DSPcomb_update(pdata->comb_data[4], smp);
	tmp+=DSPcomb_update(pdata->comb_data[5], smp);
	tmp*=1.0 / 6.0;
	tmp2=tmp;
	tmp=DSPallpass_update(pdata->allpass_data[0], tmp);	
	tmp=DSPallpass_update(pdata->allpass_data[1], tmp);	
	tmp=DSPallpass_update(pdata->allpass_data[2], tmp);	
	tmp=DSPallpass_update(pdata->allpass_data[3], tmp);	
	tmp+=tmp2;

	return tmp;
}

void *init(void)
{
	struct plugin_data *pdata;

	pdata=(struct plugin_data *)calloc(sizeof(struct plugin_data), 1);
	pdata->window=NULL;
	pdata->rscale=1.0;
	pdata->reverb_time=2.0;
	pdata->gain_wet=0.2;
	pdata->gain_dry=0.8;
	pdata->filter_freq=10000.0;
	pdata->sampling_frequency=(int)MAX_SAMPLING_FREQ;
	pdata->changed=0;
	pdata->old_smp=0.0;
	init_reverb(pdata);
	return pdata;
}

void cleanup(void *data)
{
	struct plugin_data *pdata;

	pdata=data;
	if(pdata->window) gtk_widget_destroy(pdata->window);
	cleanup_reverb(pdata);
	free(data);
}

void configure(void *data)
{
	struct plugin_data *pdata;
	GtkWidget *vbox, *hbox;
	GtkWidget *hscale, *label;
	GtkObject *adj;
	
	pdata=data;
	
	if(pdata->window != NULL) return;
	pdata->window=gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(pdata->window), "Reverb Plugin");
	gtk_container_set_border_width(GTK_CONTAINER(pdata->window), 10);
	gtk_widget_set_usize(pdata->window, 300, 150);
	gtk_signal_connect(GTK_OBJECT(pdata->window), "destroy", GTK_SIGNAL_FUNC(config_destroy), pdata);
	vbox=gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(pdata->window), vbox);
	gtk_widget_show(vbox);

	label=gtk_label_new("Reverb time (s)");
	hbox=gtk_hbox_new(FALSE, 0);
	gtk_widget_show(hbox);
	gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);
	gtk_widget_show(label);
	gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
	adj=gtk_adjustment_new(pdata->reverb_time, 0.5, 8.0, 0.1, 0.1, 0.0);
	gtk_signal_connect(GTK_OBJECT(adj), "value_changed", GTK_SIGNAL_FUNC(reverb_time_update), pdata);
	hscale=gtk_hscale_new(GTK_ADJUSTMENT(adj));
	gtk_widget_show(hscale);
	gtk_box_pack_start(GTK_BOX(hbox), hscale, TRUE, TRUE, 0);

	label=gtk_label_new("Wet gain (%)");
	hbox=gtk_hbox_new(FALSE, 0);
	gtk_widget_show(hbox);
	gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);
	gtk_widget_show(label);
	gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
	adj=gtk_adjustment_new(pdata->gain_wet * 100.0, 0.0, 200.0, 1.0, 1.0, 0.0);
	gtk_signal_connect(GTK_OBJECT(adj), "value_changed", GTK_SIGNAL_FUNC(wet_gain_update), pdata);
	hscale=gtk_hscale_new(GTK_ADJUSTMENT(adj));
	gtk_widget_show(hscale);
	gtk_box_pack_start(GTK_BOX(hbox), hscale, TRUE, TRUE, 0);

	label=gtk_label_new("Dry gain (%)");
	hbox=gtk_hbox_new(FALSE, 0);
	gtk_widget_show(hbox);
	gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);
	gtk_widget_show(label);
	gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
	adj=gtk_adjustment_new(pdata->gain_dry * 100.0, 0.0, 200.0, 1.0, 1.0, 0.0);
	gtk_signal_connect(GTK_OBJECT(adj), "value_changed", GTK_SIGNAL_FUNC(dry_gain_update), pdata);
	hscale=gtk_hscale_new(GTK_ADJUSTMENT(adj));
	gtk_widget_show(hscale);
	gtk_box_pack_start(GTK_BOX(hbox), hscale, TRUE, TRUE, 0);

	label=gtk_label_new("Filter freq (Hz)");
	hbox=gtk_hbox_new(FALSE, 0);
	gtk_widget_show(hbox);
	gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);
	gtk_widget_show(label);
	gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
	adj=gtk_adjustment_new(pdata->filter_freq, 100.0, 10000.0, 100.0, 1000.0, 0.0);
	gtk_signal_connect(GTK_OBJECT(adj), "value_changed", GTK_SIGNAL_FUNC(lowpass_freq_update), pdata);
	hscale=gtk_hscale_new(GTK_ADJUSTMENT(adj));
	gtk_widget_show(hscale);
	gtk_box_pack_start(GTK_BOX(hbox), hscale, TRUE, TRUE, 0);

	gtk_widget_show(pdata->window);
}


int process(void *data, short int *smpdata, int size, int smpfreq, int nchan)
{
	int i;
	float smp, smpl, smpr, tmp, tmp2;
	struct plugin_data *pdata;


	pdata=data;
	if((pdata->sampling_frequency != smpfreq) || (pdata->changed))
	{
		pdata->sampling_frequency=smpfreq;
		pdata->changed=0;
		modify_reverb(pdata);
	}

	if(nchan == 1)
	{
	    for(i=0; i < size; i++)
	    {
	    	smp=(float)smpdata[i];
		
		smp=0.01 * pdata->old_smp + smp * 0.99; // DC remove
		pdata->old_smp=pdata->old_smp - smp;
		
		
		tmp=DSPcomb_update(pdata->comb_data[0], smp);
		tmp+=DSPcomb_update(pdata->comb_data[1], smp);
		tmp+=DSPcomb_update(pdata->comb_data[2], smp);
		tmp+=DSPcomb_update(pdata->comb_data[3], smp);
		tmp+=DSPcomb_update(pdata->comb_data[4], smp);
		tmp+=DSPcomb_update(pdata->comb_data[5], smp);
		tmp*=1.0 / 6.0;
		tmp=DSPallpass_update(pdata->allpass_data[0], tmp);	
		tmp=DSPallpass_update(pdata->allpass_data[1], tmp);	
		tmp=DSPallpass_update(pdata->allpass_data[2], tmp);	
		tmp=DSPallpass_update(pdata->allpass_data[3], tmp);	
		
		smp=smp * pdata->gain_dry + pdata->gain_wet * tmp;
		smp=check_range(smp);
		smpdata[i]=(short int)smp;
	    }
	}
	else
	    if(nchan == 2)
	    {
		for(i=0; i < size; i+=2)
		{
	    	    smp=(float)smpdata[i] + (float)smpdata[i + 1];
		    
		    smp=0.01 * pdata->old_smp + smp * 0.99; // DC remove
		    pdata->old_smp=pdata->old_smp - smp;
		    		    
		    tmp=DSPcomb_update(pdata->comb_data[0], smp);
		    tmp+=DSPcomb_update(pdata->comb_data[1], smp);
		    tmp+=DSPcomb_update(pdata->comb_data[2], smp);
		    tmp+=DSPcomb_update(pdata->comb_data[3], smp);
		    tmp+=DSPcomb_update(pdata->comb_data[4], smp);
		    tmp+=DSPcomb_update(pdata->comb_data[5], smp);
		    tmp*=1.0 / 6.0;
		    tmp=DSPallpass_update(pdata->allpass_data[0], tmp);	
		    tmp=DSPallpass_update(pdata->allpass_data[1], tmp);	
		    smpl=DSPallpass_update(pdata->allpass_data[2], tmp);	
		    smpr=DSPallpass_update(pdata->allpass_data[3], tmp);	
				    
		    smpl=(float)smpdata[i] * pdata->gain_dry + pdata->gain_wet * smpl;
		    smpr=(float)smpdata[i + 1] * pdata->gain_dry + pdata->gain_wet * smpr;		    
		    smpl=check_range(smpl);
		    smpr=check_range(smpr);		    
		    smpdata[i]=(short int)smpl;
		    smpdata[i + 1]=(short int)smpr;
		}
	    }
	

	return size;
}



